/* don't read this code, adapted from another project, not good (but
 * should not crash/shit on bad input!)
 */
#include "mp4parser.h"
#include <stdio.h>
#include <setjmp.h>
#include <string.h>
#include <stdint.h>

#define V(x) ((((uint32_t)(((x)[0]) & 255)) << 24) | \
              (((uint32_t)(((x)[1]) & 255)) << 16) | \
              (((uint32_t)(((x)[2]) & 255)) << 8) | \
               ((uint32_t)(((x)[3]) & 255)))
#define Z(a,b,c,d) ((((uint32_t)((a) & 255)) << 24) | \
                    (((uint32_t)((b) & 255)) << 16) | \
                    (((uint32_t)((c) & 255)) << 8) | \
                     ((uint32_t)((d) & 255)))

#define MOOF Z('m','o','o','f')
#define TRAF Z('t','r','a','f')
#define UUID Z('u','u','i','d')

typedef struct {
  char type[4];
  unsigned long offset;
  unsigned long offset_data;
  unsigned long len;
} basebox;

typedef struct {
  jmp_buf j;
  unsigned char *b;
  unsigned long size;
  unsigned long pos;
} buffer;

typedef union {
  basebox base;
} box;

uint32_t getbyte(buffer *b)
{
  if (b->size < b->pos + 4) longjmp(b->j, 1);
  b->pos++;
  return b->b[b->pos-1];
}

uint32_t getu32(buffer *b)
{
  unsigned char buf[4];
  uint32_t r;
  if (b->size < b->pos + 4) longjmp(b->j, 1);
  memcpy(buf, b->b + b->pos, 4);
  b->pos += 4;
  r = (buf[0] << 24) |
      (buf[1] << 16) |
      (buf[2] << 8) |
      (buf[3]);
  return r;
}

uint64_t getu64(buffer *b)
{
  unsigned char buf[8];
  uint64_t r;
  if (b->size < b->pos + 8) longjmp(b->j, 1);
  memcpy(buf, b->b + b->pos, 8);
  b->pos += 8;
  r = ((uint64_t)buf[0] << (32+24)) |
      ((uint64_t)buf[1] << (32+16)) |
      ((uint64_t)buf[2] << (32+8)) |
      ((uint64_t)buf[3] << 32) |
      ((uint64_t)buf[4] << 24) |
      ((uint64_t)buf[5] << 16) |
      ((uint64_t)buf[6] << 8) |
      ((uint64_t)buf[7]);
  return r;
}

void nextbox(buffer *b, box *x)
{
  int pos = b->pos;
  uint64_t l = getu32(b);
  uint32_t t = getu32(b);
  if (l == 1) l = getu64(b);
  if (l == 0) l = b->size - pos;
  memset(x, 0, sizeof(box));
  x->base.type[0] = (t >> 24) & 255;
  x->base.type[1] = (t >> 16) & 255;
  x->base.type[2] = (t >> 8) & 255;
  x->base.type[3] = t & 255;
  x->base.offset = pos;
  x->base.offset_data = b->pos;
  x->base.len = l;
  b->pos = pos;
}

uint64_t get_next_time(char *in, int len)
{
  box box;
  buffer buf;

  buf.b = (unsigned char *)in;
  buf.size = len;
  buf.pos = 0;

  if (setjmp(buf.j)) {
    printf("WARNING: TFRF not found\n");
    return 0;
  }

  /* look for moof */
  while (1) {
    nextbox(&buf, &box);
    if (V(box.base.type) == MOOF) break;
  }

  buf.pos = box.base.offset_data;
  buf.size = buf.pos+box.base.len - (box.base.offset_data - box.base.offset);

  /* in moof, look for traf */
  while (1) {
    nextbox(&buf, &box);
    buf.pos += box.base.len;
    if (V(box.base.type) == TRAF) break;
  }

  buf.pos = box.base.offset_data;
  buf.size = buf.pos+box.base.len - (box.base.offset_data - box.base.offset);

  /* in traf, look for tfrf */
  while (1) {
    nextbox(&buf, &box);
    buf.pos += box.base.len;
    if (V(box.base.type) == UUID) {
      int i;
      unsigned char tfrf_id[16] =
          { 0xD4, 0x80, 0x7E, 0xF2, 0xCA, 0x39, 0x46, 0x95,
            0x8E, 0x54, 0x26, 0xCB, 0x9E, 0x46, 0xA7, 0x9F };
      buffer b2 = buf;
      b2.pos = box.base.offset_data;
      b2.size = b2.pos+box.base.len-(box.base.offset_data - box.base.offset);
      for (i = 0; i < 16; i++) if (getbyte(&b2) != tfrf_id[i]) break;
      if (i == 16) { buf = b2; break; }
    }
  }

  /* version 1 */
  if (getbyte(&buf) != 1) {
    printf("WARNING: TFRF version should be 1\n");
    return 0;
  }
  /* 3 reserved bytes (24 bits) */
  getbyte(&buf); getbyte(&buf); getbyte(&buf);
  /* fragment count (we want > 0) */
  if (getbyte(&buf) < 1) {
    printf("WARNING: TFRF fragment count less than 1\n");
    return 0;
  }
  /* return first FragmentAbsoluteTime64 (for the next fragment) */
  return getu64(&buf);
}
